/*
 *                   jfjji,.           H A M M E R H E A D  S H A R K W A R E
 *                  ,#######EL:                  http://www.hhsw.de
 *                   .,j######Kj       
 *                    ;W########G:     This  code  is  free software; you can
 *                   j#####G ,D#L:     redistribute it and/or modify it under
 *             .,;;,G#####D.           the  terms  of  the GNU General Public
 *           jE##########G             License   as  published  by  the  Free
 *             .,W######D.             Software  Foundation; either version 2
 *             :L#####K##G             of  the  License,  or (at your option)
 *           .f#####G;.t##:            any later version.
 *         ;L###ELi.    ,D,            
 *       iEEGWj                        This  code  is distributed in the hope
 *      tW;                            that  it  will  be useful, but without
 *     jf                              any warranty; without even the implied
 *    .Kt                              warranty of merchantability or fitness
 *    i:                               for  a particular purpose. See the GNU
 *    ;                                General   Public   License   for  more
 *    .                                details (http://www.gnu.org).
 */
#ifndef bbdock_Raise_hh
#define bbdock_Raise_hh

#include <X11/Xlib.h>
#include <X11/Xatom.h>

namespace bbdock
{
	/**
	 * Raises a window and switches to its workspace
	 *
	 * @author mf@hhsw.de
	 * @version 0.01
	 */
	class Raise
	{
		public:
			Raise( Display * );
			virtual ~Raise() {}
			bool raise( const char * ) const;

		private:
			Display	*display;
			Window	root;

			/**
			 * Simple iterator for easy access
			 */
			class Iterator
			{
				public:
					Iterator( Window *i, unsigned long n )
					{
						item = i;
						items = n;
					}
					~Iterator()
					{
						XFree( item );
					}
					Window fetch()
					{
						if( --items < 1 )
							return 0;

						return item[items];
					}

				private:
					Window			*item;
					unsigned long	items;
			};

			const bool validateWindow( Window ) const;
			unsigned char *getProperty( Window, Atom, const char *, 
				unsigned long * = 0 ) const;
			char *getWindowTitle( Window ) const;
			Raise::Iterator *getClientList() const;
			void sendClientMessage( Window w, const char *, 
				unsigned long = 0, unsigned long = 0, unsigned long = 0, 
				unsigned long = 0, unsigned long = 0 ) const;
			void activateWindow( Window ) const; 
	};
}

#endif
